/* PlistIO.java created by mfirlik on Tue 16-May-2000 */

import com.apple.yellow.foundation.*;
import com.apple.yellow.eocontrol.*;
import com.apple.yellow.eoaccess.*;
import com.apple.yellow.webobjects.*;
import java.io.*;
import java.util.*;


public class PlistIO extends EOCustomObject {

	public static NSMutableDictionary loadDictionaryFromFile(String fileName) {

		String path;
		File file;

		// Define the path
		path = ((Application)Application.application()).resourceManager().pathForResourceNamed(fileName,null,null);

		if(path != null) {
			file = new File(path);
			return (NSMutableDictionary)objectFromPListFile(file);
		} else {
			System.err.println("NO PLIST '" + fileName + "' FOUND.");
			return new NSMutableDictionary();
		}

	}

   public static NSMutableDictionary objectFromPListFile(File file) {

		NSMutableDictionary obj = null;

		try {
			NSDictionary theObjects = (NSDictionary)NSPropertyListSerialization.propertyListFromString(stringFromFile(file));
			obj = new NSMutableDictionary(theObjects);
		} catch (IOException ioexception) {
			System.out.println(ioexception.toString());
		}

		return obj;
   }

   public static String stringFromFile(File file) throws IOException {
       if (file == null) {
           throw new IOException("null file");
       }
       int size = (int) file.length();
       FileInputStream fileInputStream = new FileInputStream(file);
       byte[] data = new byte[size];
       int bytesRead = 0;
       while (bytesRead < size) {
           bytesRead += fileInputStream.read(data, bytesRead, size-bytesRead);
       }
       fileInputStream.close();
       return new String(data);
   }


}
