// Generated by the WebObjects Wizard Wed May 17 23:33:57 US/Central 2000

import com.apple.yellow.foundation.*;
import com.apple.yellow.webobjects.*;
import com.apple.yellow.eocontrol.*;
import com.apple.yellow.eoaccess.*;

public class iTools extends WOComponent {

	// ***********************
	// *  Required      
	// ***********************

	protected Picture aPicture, selectedPicture;
	protected String aList, aTemplate;
	protected String selectedTemplate, selectedOutput;
	protected String titleText, subTitleText, messageString;
	protected String greeting, openingParagraph, closingParagraph, salutation, yourName;
	protected String bumperMessage;
	

	// ***********************
	// *  List Methods
	// ***********************

	public NSArray templateList() {
		String templateNameList[] = {"iPoster", "iBumperSticker", "iQuit", "iConfess"};
		return new NSArray(templateNameList);
	}

	public NSArray pictureList() {
		return (NSArray)Picture.pictureList();
	}

	public NSArray outputList() {
		String outputList[] = {"PDF", "Flash"};
		return new NSArray(outputList);
	}


	// ***********************
	// *  Create the template
	// ***********************

	public WOComponent createTemplate() {

		// Define the next page
   		WOComponent nextPage = null;

		// Set (check) the error status
		messageString = errorMessage();

		// If an error status exists, return null
		if (messageString.length() > 0) {
			return nextPage;

		// Otherwise generate the template
		} else {

			// Save all the template information in the session (so we can come back)
			// We get an idString in return, which we use in a DirectAction ...
			String directActionURL = saveTemplateInfo();

			// Determine, based on the output selection, which component to return
			if (selectedOutput != null && selectedOutput.equals("PDF"))
				nextPage = (WOComponent)pageWithName("ReportMillPage");
			else if (selectedOutput != null && selectedOutput.equals("Flash"))
				nextPage = (WOComponent)pageWithName("RMFlashPage");

			// Set the selected template
			nextPage.takeValueForKey(selectedTemplate, "template");

			// Set up the resourceManager to access file resources
			WOResourceManager rm = application().resourceManager();
			WORequest request = context().request();

			// Create the userInfo dictionary for the content, since we don't have objects
			NSMutableDictionary userInfo = new NSMutableDictionary();

			if (selectedTemplate.equals("iPoster")) {
				userInfo = iPosterInfo(rm, request);
			} else if (selectedTemplate.equals("iQuit")) {
				userInfo = iQuitInfo(rm, request);
			} else if (selectedTemplate.equals("iBumperSticker")) {
				userInfo = iBumperStickerInfo(rm, request);
			} else if (selectedTemplate.equals("iConfess")) {
				userInfo = iConfessInfo(rm, request);
			}

			// Add the updater URL and info			
			userInfo.setObjectForKey("Update Me", "updateString");
			userInfo.setObjectForKey(directActionURL, "updateURL");
			nextPage.takeValueForKey(userInfo, "userInfo");

			// Before we return the next page, save the template information in the session (roundeavous)
			return nextPage;
		}
	}

	public NSMutableDictionary iPosterInfo(WOResourceManager rm, WORequest request) {

		NSMutableDictionary userInfo = new NSMutableDictionary();
		userInfo.setObjectForKey(titleText, "titleText");
		userInfo.setObjectForKey(subTitleText, "subTitleText");
                userInfo.setObjectForKey(rm.pathForResourceNamed(selectedPicture.fileName(), null, null), "backgroundImage");
		userInfo.setObjectForKey(selectedPicture.mimeType(), "imageType");

		return userInfo;
	}

	public NSMutableDictionary iQuitInfo(WOResourceManager rm, WORequest request) {

		NSMutableDictionary userInfo = new NSMutableDictionary();
		userInfo.setObjectForKey(greeting, "greeting");
		userInfo.setObjectForKey(openingParagraph, "openingParagraph");
		userInfo.setObjectForKey(closingParagraph, "closingParagraph");
		userInfo.setObjectForKey(salutation, "salutation");
	    userInfo.setObjectForKey(yourName, "yourName");

		return userInfo;
	}

	public NSMutableDictionary iBumperStickerInfo(WOResourceManager rm, WORequest request) {

		NSMutableDictionary userInfo = new NSMutableDictionary();
		userInfo.setObjectForKey(titleText, "titleText");
		userInfo.setObjectForKey(subTitleText, "subTitleText");
	    userInfo.setObjectForKey(rm.pathForResourceNamed(selectedPicture.fileName(), null, null), "backgroundImage");
		userInfo.setObjectForKey(selectedPicture.mimeType(), "imageType");

  		return userInfo;
	}

	public NSMutableDictionary iConfessInfo(WOResourceManager rm, WORequest request) {

		NSMutableDictionary userInfo = new NSMutableDictionary();
		userInfo.setObjectForKey(titleText, "titleText");
		userInfo.setObjectForKey(subTitleText, "subTitleText");
	    userInfo.setObjectForKey(rm.pathForResourceNamed(selectedPicture.fileName(), null, null), "backgroundImage");
		userInfo.setObjectForKey(selectedPicture.mimeType(), "imageType");
		return userInfo;
	}
	

	public String saveTemplateInfo() {

		// Create the new dictionary
		NSMutableDictionary templateInfo = new NSMutableDictionary();

		// Set all the specific values
   		templateInfo.setObjectForKey(selectedTemplate, "selectedTemplate");
   		templateInfo.setObjectForKey(selectedOutput, "selectedOutput");

   		if (selectedTemplate.equals("iPoster")) {

			templateInfo.setObjectForKey(selectedPicture, "selectedPicture");
			templateInfo.setObjectForKey(titleText, "titleText");
			templateInfo.setObjectForKey(subTitleText, "subTitleText");

   		} else if (selectedTemplate.equals("iQuit")) {

			templateInfo.setObjectForKey(greeting, "greeting");
			templateInfo.setObjectForKey(salutation, "salutation");
			templateInfo.setObjectForKey(openingParagraph, "openingParagraph");
			templateInfo.setObjectForKey(closingParagraph, "closingParagraph");
		}

		// Create the URL and return it
		String sessionID = session().sessionID();
		String idString = Session.addTemplateToWorkspace(templateInfo);

   		return new String(Application.hostIP + "/cgi-bin/WebObjects/WOTestApp.woa/wa/editTemplate?wosid="+sessionID+"&templateId="+idString);
	}
	
	public String errorMessage() {

		// Check the error status, and return a message appropriately
   		if (selectedOutput == null)
			return new String("Please select an output format.");

		else if (selectedTemplate == null)
			return new String("Please select a template type.");

		else if (selectedTemplate.equals("iPoster")) {

			if (selectedPicture == null)
				return new String("Please select a picture.");
			if (subTitleText == null)
				return new String("Please enter subtitle text");
			if (titleText == null)
				return new String("Please enter a title");

		} else if (selectedTemplate != null && selectedTemplate.equals("iPoster")) {

			if (salutation == null)
				return new String("Please enter a salutation.");
			if (closingParagraph == null)
				return new String("Please enter some closing words.");
			if (openingParagraph == null)
				return new String("Please enter some opening words.");
			if (yourName == null)
				return new String("Please enter your name.");
		}

		return new String();
		
	}


	// ***********************
	// *  Selection Methods
	// ***********************

	public void makeSelection() {}

	public boolean hasSelectedTemplate() {
		if (selectedTemplate == null)
			return true;
		else
			return false;
	}

	public boolean iPosterIsSelected() {
		if (selectedTemplate != null && selectedTemplate.equals("iPoster"))
			return true;
		else
			return false;
	}

	public boolean iQuitIsSelected() {
		if (selectedTemplate != null && selectedTemplate.equals("iQuit"))
			return true;
		else
			return false;
	}
	
		
	// ***********************
	// *  Accessors
	// ***********************

	public void setSelectedTemplate(String aTemplate) {
		selectedTemplate = aTemplate;
	}

	public void setSelectedPicture(Picture thePicture) {
		selectedPicture = thePicture;
	}
	
	public void setTitleText(String aValue) {
		titleText = aValue;
	}

	public void setSubTitleText(String aValue) {
		subTitleText = aValue;
	}

	public void setMessageString(String aValue) {
		messageString = aValue;
	}
	
	public void setGreeting(String aValue) {
		greeting = aValue;
	}
	
	public void setOpeningParagraph(String aValue) {
		openingParagraph = aValue;
	}
	
   	public void setClosingParagraph(String aValue) {
		closingParagraph = aValue;
	}
	
	public void setSalutation(String aValue) {
		salutation = aValue;
	}
	
	public void setYourName(String aValue) {
		yourName = aValue;
	}
	
	public void setBumperMessage(String aValue) {
		bumperMessage = aValue;
	}
	

}
